﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.7
@EndOfDesignText@
#Event:DragDetected(e As DragEventX)
#Event:DragOver(e As DragEventX)
#Event:DragEntered(e As DragEventX)
#Event:DragExited(e As DragEventX)
#Event:DragDropped(e As DragEventX, Files As List)


'Class module
Sub Class_Globals
	Private fx As JFX
	Public TRANSFERMODE_COPY, TRANSFERMODE_LINK, TRANSFERMODE_MOVE, _
		TRANSFERMODE_ANY, TRANSFERMODE_COPY_OR_MOVE, TRANSFERMODE_NONE As JavaObject
	
	Private SourceEvents As Map
	Private TargetEvents As Map
	Private DragSource As Node
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Dim TransferMode As JavaObject
	TransferMode.InitializeStatic("javafx.scene.input.TransferMode")
	TRANSFERMODE_COPY = TransferMode.GetField("COPY")
	TRANSFERMODE_LINK = TransferMode.GetField("LINK")
	TRANSFERMODE_MOVE = TransferMode.GetField("MOVE")
	TRANSFERMODE_ANY = TransferMode.GetField("ANY")
	TRANSFERMODE_COPY_OR_MOVE = TransferMode.GetField("COPY_OR_MOVE")
	TRANSFERMODE_NONE = TransferMode.GetField("NONE")

	SourceEvents.Initialize
	TargetEvents.Initialize

End Sub


Sub MakeDragSource(Source As Node, Module As Object, EventName As String)	
	SourceEvents.Put(Source, CreateMap("Module":Module, "Sub":EventName))	
	CreateEvent(Source, "setOnDragDetected", "Source_DragDetected")
End Sub

Sub Source_DragDetected_Event(MethodName As String, Args() As Object)
	DragSource = Sender
	
	If DragSource.IsInitialized Then
		Dim SourceEvent As Map = SourceEvents.Get(DragSource)
		
		If SourceEvent.IsInitialized And Args.Length > 0 Then		
			Dim DragEvent As JavaObject = Args(0)
			Dim e As DragEventX
			e.Initialize(DragEvent)
			
			CallIfExists2(SourceEvent.Get("Module"), $"${SourceEvent.Get("Sub")}_DragDetected"$, e)
		End If	
	End If
End Sub

Sub MakeDragTarget(Target As Node, Module As Object, EventName As String)
	TargetEvents.Put(Target, CreateMap("Module":Module, "Sub":EventName))
	CreateEvent(Target, "setOnDragOver", "Target_DragOver")
	CreateEvent(Target, "setOnDragEntered", "Target_DragEntered")
	CreateEvent(Target, "setOnDragEntered", "Target_DragEntered")
	CreateEvent(Target, "setOnDragExited", "Target_DragExited")
	CreateEvent(Target, "setOnDragDropped", "Target_DragDropped")
End Sub

Sub Target_DragOver_Event(MethodName As String, Args() As Object)
	'Get the target:
'	Log(MethodName)
'	Log(Args)
	Dim Target As Node = Sender
	
	If Target.IsInitialized Then
		'Find the target events:
		Dim TargetEvent As Map = TargetEvents.Get(Target)
		
		If TargetEvent.IsInitialized And Args.Length > 0 Then
			Dim DragEvent As JavaObject = Args(0)
			If DragEvent.RunMethod("getGestureSource", Null) <> Null And DragEvent.RunMethod("getGestureSource", Null) <> Target And DragEvent.RunMethodJo("getDragboard", Null).RunMethod("hasString", Null) = True Then
			
				Dim e As DragEventX
				e.Initialize(DragEvent)
			
				CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragOver"$, e)
			Else
				Dim e As DragEventX
				e.Initialize(DragEvent)
			
				CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragOver"$, e)
			End If
		End If	
	End If	
End Sub

Sub Target_DragEntered_Event(MethodName As String, Args() As Object)
	
'	Log(MethodName)
'	For Each arg In Args
'		Log(arg)
'	Next	
	
	'Get the target:
	Dim Target As Node = Sender
	
	If Target.IsInitialized Then
		'Find the target events:
		Dim TargetEvent As Map = TargetEvents.Get(Target)
		
		If TargetEvent.IsInitialized And Args.Length > 0 Then
			Dim DragEvent As JavaObject = Args(0)
			If DragEvent.RunMethod("getGestureSource", Null) <> Null And DragEvent.RunMethod("getGestureSource", Null) <> Target And DragEvent.RunMethodJo("getDragboard", Null).RunMethod("hasString", Null) = True Then
			
				Dim e As DragEventX
				e.Initialize(DragEvent)
			
				CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragEntered"$, e)
			
			Else
				Dim e As DragEventX
				e.Initialize(DragEvent)
			
				CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragEntered"$, e)
			
			End If
		End If	
	End If	
End Sub

Sub Target_DragDropped_Event(MethodName As String, Args() As Object)
	
'	Log(MethodName)
'	For Each arg In Args
'		Log(arg)
'	Next	
	
	'Get the target:
	Dim Target As Node = Sender
	
	If Target.IsInitialized Then
		'Find the target events:
		Dim TargetEvent As Map = TargetEvents.Get(Target)
		
'		Log($"1"$)
		
		If TargetEvent.IsInitialized And Args.Length > 0 Then
			Dim DragEvent As JavaObject = Args(0)
			If DragEvent.RunMethod("getGestureSource", Null) <> Null And DragEvent.RunMethod("getGestureSource", Null) <> Target And DragEvent.RunMethodJo("getDragboard", Null).RunMethod("hasString", Null) = True Then
			
'				Log($"2"$)
			
				Dim e As DragEventX
				e.Initialize(DragEvent)
			
				CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragEntered"$, e)
			
			Else
'				Log($"3"$)
				
				Dim Dataformat As JavaObject
				Dataformat.InitializeStatic("javafx.scene.input.DataFormat")
				
				
'				Log($"do you still have the error?"$)
'				Log("your files should be listed below:")
				Dim files As List = DragEvent.RunMethodJo("getDragboard", Null).RunMethod("getContent", Array(Dataformat.GetField("FILES")))
'				Log(files)

				Dim e As DragEventX
				e.Initialize(DragEvent)

			
				CallIfExists3(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragDropped"$, e, files)
			
			End If
		End If	
	End If	
End Sub

Sub Target_DragExited_Event(MethodName As String, Args() As Object)
	'Get the target:
	Dim Target As Node = Sender
	
	If Target.IsInitialized Then
		'Find the target events:
		Dim TargetEvent As Map = TargetEvents.Get(Target)
		
		If TargetEvent.IsInitialized And Args.Length > 0 Then
			Dim DragEvent As JavaObject = Args(0)
			
			Dim e As DragEventX
			e.Initialize(DragEvent)
		
			CallIfExists2(TargetEvent.Get("Module"), $"${TargetEvent.Get("Sub")}_DragExited"$, e)
			
		End If	
	End If	
End Sub

'Sub SetDragModeAndData(TransferMode As Object, DataId As String, DataObject() As Object)
'	'Create the Dragboard:
'	Dim Dragboard As JavaObject
'	Dragboard = AsJo(DragSource).RunMethod("startDragAndDrop", Array(TransferMode))
'	
'	'Create the content:
'	Dim Content As JavaObject
'	Content.InitializeNewInstance("javafx.scene.input.ClipboardContent", Null)
'	Content.RunMethod("putString", Array(DataId))
'	
'	'Put the content:
'	Dragboard.RunMethod("setContent", Array(Content))
'End Sub


Private Sub CallIfExists2(Module As Object, SubName As String, Arg As Object)
	If SubExists(Module, SubName) Then CallSub2(Module, SubName, Arg)
End Sub

Private Sub CallIfExists3(Module As Object, SubName As String, Arg As Object, Files As List)
	If SubExists(Module, SubName) Then CallSub3(Module, SubName, Arg, Files)
End Sub

Private Sub CreateEvent(TargetNode As JavaObject, EventHandler As String, EventName As String)
	Dim e As Object = AsJo(TargetNode).CreateEvent("javafx.event.EventHandler", EventName, False)
	AsJo(TargetNode).RunMethod(EventHandler, Array(e))
End Sub

Private Sub AsJo(Jo As JavaObject) As JavaObject
	Return Jo
End Sub	
