﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4.7
@EndOfDesignText@
'Static Global code module
Sub Process_Globals
	Private fx As JFX
	Public QuitProcess As Boolean
End Sub

'### Returns only extension from a fullpath
Public Sub GetExtensionOnly(sFilename As String) As String
	Dim Dummy As String
    
   Dummy = sFilename.SubString(sFilename.Length - 4+1)
	Return Dummy
End Sub

'### Returns the filename from a fullpath
Public Sub GetFileNameOnly(path As String) As String
	Dim pos As Long

    '### Get position of last '.'.
    pos = path.lastIndexOf(".")
    '### If there wasn't any '.' just return the string as is.
    If (pos = -1) Then Return path
    '### Otherwise Return the string, up To the dot.
    Return path.SubString2(0, pos)
End Sub

'### Returns the filename from a fullpath
Sub pkGetFileName(path As String) As String
	Dim JO As JavaObject
	JO.InitializeNewInstance("java.io.File", Array As Object(path))
	Return JO.RunMethod("getName", Null)
End Sub

'### Returns the filepath from a fullpath
Sub pkGetFilePath(path As String) As String
	Dim JO As JavaObject
	JO.InitializeNewInstance("java.io.File", Array As Object(path))
	Dim n As String = JO.RunMethod("getName", Null)
	Dim p As String = JO.RunMethod("getPath", Null)
	p = p.Replace(n, "")
	Return p
End Sub

Sub pkGetFolderPath(Path As String) As String
	Dim JO As JavaObject
	Dim bFolder As Boolean
	
	JO.InitializeNewInstance("java.io.File", Array As Object(Path))
	bFolder = JO.RunMethod("isDirectory", Null)
	If bFolder Then
		Return Path
	End If
	Return ""
End Sub

Public Sub pkReadFileAsList(dirPath As String, sFilename As String) As List
Dim List1 As List

	List1 = File.ReadList(dirPath, sFilename)
	For i = 0 To List1.Size - 1
'	  Log(List1.Get(i))
	Next
	Return List1
End Sub

Public Sub pkReadFileAsString(dirPath As String, sFilename As String) As String
	Dim text As String
	text = File.ReadString(dirPath, sFilename)
'	Log(text)
	Return text
End Sub

Public Sub pkFindNreplace(str As String, strSource As String, strReplace As String) As String
	Dim pkStr As String
	
	pkStr = str
	pkStr = pkStr.Replace(strSource, strReplace)
	Return pkStr
End Sub

public Sub pkGetOS() As String
Dim os As String = GetSystemProperty("os.name", "").ToLowerCase
	Dim pkOS As String

'	Log(os)

	If os.Contains("win") Then
'	   Log("Windows")
	   pkOS = "Windows"
	Else If os.Contains("mac") Then
'		Log("OS X")
		pkOS = "OS X"
	Else
'	   Log("Linux")
	   pkOS = "Linux"
	End If
	Return pkOS
End Sub

Sub setFormAlwaysOnTop(frm As Object, Value As Boolean)
	Dim joForm As JavaObject = frm
	Dim stage As JavaObject = joForm.GetField("stage")

    stage.RunMethod("setAlwaysOnTop", Array(Value))
End Sub

Sub ConvertTicksToTimeString(t As Long) As String
    Dim  hours, minutes, seconds As Int
	
    hours = t / DateTime.TicksPerHour
    minutes = (t Mod DateTime.TicksPerHour) / DateTime.TicksPerMinute
    seconds = (t Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond
	Log("hours: " & hours & " minutes: " & minutes & " seconds: " & seconds)
    Return NumberFormat(hours, 2, 0) & ":" & NumberFormat(minutes, 2, 0) & ":" & NumberFormat(seconds, 2, 0)
End Sub

Sub ConvertTicksToPostFix(t As Long) As String
	Dim  hours, minutes, seconds As Int

    hours = t / DateTime.TicksPerHour
    minutes = (t Mod DateTime.TicksPerHour) / DateTime.TicksPerMinute
    seconds = (t Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond
'	Log("hours:" & hours & " minutes:" & minutes & " seconds:" & seconds)
	
	Return NumberFormat(hours, 2, 0).Replace(",", "") & _
			NumberFormat(minutes, 2, 0).Replace(",", "") & _
			NumberFormat(seconds, 2, 0).Replace(",", "")
End Sub

''### Check if a file is a folder
''### Return true if file is folder
'Sub isDir(f As String) As Boolean
'	Dim fileO As JavaObject
'	fileO.InitializeNewInstance("java.io.File", Array As Object(f))
'	Return fileO.RunMethod("isDirectory", Null)
'End Sub

Sub CheckJavaVersion(sJavaVersionTarget As String) As Boolean
	Dim result As Boolean = True
	Dim sJavaVersionCurrent As String = GetSystemProperty("java.version","0.0.0_00")
	
	'### Clean up the version information by removing . and _
	sJavaVersionCurrent = sJavaVersionCurrent.Replace(".", "").Replace("_", "")
	sJavaVersionTarget = sJavaVersionTarget.Replace(".", "").Replace("_", "")
	
	'### Convert into int to be able to compare
	Dim nJavaVersionCurrent As Int = sJavaVersionCurrent
	Dim nJavaVersionTarget As Int = sJavaVersionTarget
	If nJavaVersionCurrent < nJavaVersionTarget Then
		result = False
	End If
	Return result
End Sub

'### Get Java Version
Sub GetJavaVersion As String
	Return GetSystemProperty("java.version","0.0.0_00")
End Sub